
import subprocess


class SCADFile:
  def __init__(self, filename):
    self.__filename = filename
    self.content = '\n'
    self.indent = 0

  def print(self, any, newLines=1):

    lineStart = ' ' * self.indent
    lineEnd   = '\n' * newLines

    self.write(f'{lineStart}{any}{lineEnd}')

  def write(self, any):
    self.content += str(any)

  def save(self):
    with open(self.__filename, 'w') as f:
      f.write(self.content)

  def __enter__(self):
    return self

  def __exit__(self, *ignored):
    # Yes we don't behave like a real file object here as we may want to build an API to change the content before write-out
    # which is obviously impossible if we write the file line-by-line like a real file object
    self.save()


class OpenSCAD:

  ProcessBinary = ['/usr/bin/env', 'openscad']

  def __init__(self):
    pass




